// regedit.h
//
#if !defined __REGEDIT_H__
#define __REGEDIT_H__

#include <afxpriv.h>
#include <afximpl.h>

class CRegEdit : public CObject
{
	DECLARE_DYNAMIC(CRegEdit)
// Constructor/Destructor
public:
	CRegEdit();
	virtual ~CRegEdit();
	
// Attributes
public:
	HKEY	m_hRoot;	// root key
	LPCTSTR m_pszAppName;  // human readable name
	LPCTSTR m_pszRegistryKey;   // used for registry entries
	LPCTSTR m_pszProfileName;   // default based on app name

// Operations
public:
	void SetRegistryRoot(HKEY hRoot);
	void SetRegistryKey(LPCTSTR lpszRegistryKey, LPCTSTR lpszAppName);
	void SetRegistryKey(UINT nIDRegistryKey, UINT nIDAppName);
	inline HKEY GetRegistryRoot(){ return m_hRoot; }
	HKEY GetSectionKey(LPCTSTR lpszSection);
	HKEY GetAppRegistryKey();

// Implementation
public:
	UINT GetProfileInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, int nDefault);
	BOOL WriteProfileInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, int nValue);
	CString GetProfileString(LPCTSTR lpszSection, LPCTSTR lpszEntry,
							 LPCTSTR lpszDefault = NULL);
	BOOL WriteProfileString(LPCTSTR lpszSection, LPCTSTR lpszEntry,
							LPCTSTR lpszValue);
	BOOL GetProfileBinary(LPCTSTR lpszSection, LPCTSTR lpszEntry,
						  LPBYTE* ppData, UINT* pBytes);
	BOOL WriteProfileBinary(LPCTSTR lpszSection, LPCTSTR lpszEntry,
							LPBYTE pData, UINT nBytes);
	BOOL GetArrayFromBytes(LPCTSTR lpszSection, LPCTSTR lpszEntry, CAByte& data);
	BOOL WriteArrayToBytes(LPCTSTR lpszSection, LPCTSTR lpszEntry, CAByte& data);
};

#endif // !defined __REGEDIT_H__
