// SerComDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerCom.h"
#include "ScomDlg.h"
#include "Commtty.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSerComDlg dialog

char *szBaud[] =
{
	"110", "300", "600", "1200", "2400", 
	"4800", "9600", "14400", "19200",
	"38400", "56000", "57600", "115200", 
	"128000", "256000"
};
DWORD BaudTable[] =
{
	CBR_110, CBR_300, CBR_600, CBR_1200, CBR_2400,
	CBR_4800, CBR_9600, CBR_14400, CBR_19200, CBR_38400,
	CBR_56000, CBR_57600, CBR_115200, CBR_128000, CBR_256000
};
char *szDataBits[] = { "5", "6", "7", "8" };
DWORD DataBitsTable[] = { 5, 6, 7, 8 };
char *szParity[] = { "", "", "ż", "", "" };
DWORD ParityTable[] = { NOPARITY, EVENPARITY, ODDPARITY, MARKPARITY, SPACEPARITY };
char *szStopBits[] = { "1", "1.5", "2"  };
DWORD StopBitsTable[] = { ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS };

CSerComDlg::CSerComDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerComDlg::IDD, pParent)
{
	CWinApp* pApp = AfxGetApp();
	//{{AFX_DATA_INIT(CSerComDlg)
	m_gszPort = pApp->GetProfileString(_T(""), _T("szPort"), _T("COM1"));
	m_bHexShow = pApp->GetProfileInt(_T(""), _T("bHex"), 1);
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	gbHexShow = m_bHexShow;
}

void CSerComDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerComDlg)
	DDX_Control(pDX, ID1_EDIT_LHEX, m_ledit);
	DDX_CBString(pDX, ID1_COMBO_PORT, m_gszPort);
	DDX_Check(pDX, ID1_CHECK_HEX, m_bHexShow);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSerComDlg, CDialog)
	//{{AFX_MSG_MAP(CSerComDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(ID1_BTN_CONNECT, OnBtnConnect)
	ON_BN_CLICKED(ID1_BTN_DISCONNECT, OnBtnDisconnect)
	ON_BN_CLICKED(ID1_BTN_OPEN, OnBtnInsert)
	ON_BN_CLICKED(ID1_BTN_SEND, OnBtnSend)
	ON_BN_CLICKED(ID1_BTN_CLRSEND, OnBtnClearSend)
	ON_BN_CLICKED(ID1_BTN_SENDLINE, OnBtnSendLine)
	ON_BN_CLICKED(ID1_BTN_CLRLINE, OnBtnClearLine)
	ON_BN_CLICKED(ID1_BTN_CLRRECV, OnBtnClearRecv)
	ON_BN_CLICKED(ID1_BTN_TIMERAA, OnBtnTimeraa)
	ON_BN_CLICKED(ID1_BTN_STOPTIMER, OnBtnStoptimer)
	ON_BN_CLICKED(ID1_CHECK_HEX, OnCheckHex)
	ON_BN_CLICKED(ID1_BTN_CLOSE, OnBtnClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////
// غ

BOOL CSerComDlg::Create() 
{
	return CDialog::Create(IDD, NULL);
}

BOOL CSerComDlg::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message==WM_KEYDOWN && pMsg->wParam==VK_RETURN)
	{
		UINT nID = ::GetDlgCtrlID(pMsg->hwnd);
		if (nID==ID1_EDIT_LHEX)
		{
			OnBtnSendLine();
			return TRUE;
		}
		else
		{
			switch (nID)
			{
			case ID1_COMBO_PORT:
			case ID1_COMBO_BAUD:
			case ID1_COMBO_DATABITS:
			case ID1_COMBO_PARITY:
			case ID1_COMBO_STOPBITS:
			case ID1_COMBO_FLOW:
			case ID1_CHECK_HEX:
				return TRUE;
			}
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CSerComDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	//ȫھ

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->EnableMenuItem(pSysMenu->GetMenuItemID(2), MF_GRAYED);
			pSysMenu->EnableMenuItem(pSysMenu->GetMenuItemID(4), MF_GRAYED);
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//ͼ
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	//ı
	CRect rc;
	GetDlgItem(ID1_STATIC_SEND)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_resend.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_VSCROLL|ES_LEFT|ES_AUTOVSCROLL|
		ES_MULTILINE|ES_WANTRETURN, rc, this, ID1_REDIT_SEND);
	GetDlgItem(ID1_STATIC_RECV)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_rerecv.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_VSCROLL|ES_LEFT|ES_AUTOVSCROLL|
		ES_READONLY|ES_MULTILINE|ES_WANTRETURN, rc, this, ID1_REDIT_RECV);
/*	LOGFONT lf;
	memset(&lf, 0, sizeof(lf));
	lf.lfHeight = 16;
	lf.lfWeight = FW_NORMAL;
	lstrcpy(lf.lfFaceName, _T("Courier New"));
	CFont font;
	font.CreateFontIndirect(&lf);
	m_resend.SetFont(&font);
	m_rerecv.SetFont(&font);
*/
	//ʼͨѶ
	InitTTYInfo();

	//ʼͨѶϿ
	CString sBuf;
	for (int i=0; i<MAXPORTS; i++)
	{
		sBuf.Format("COM%d", i+1);
		((CComboBox*)GetDlgItem(ID1_COMBO_PORT))->AddString(sBuf);
    }
    ((CComboBox*)GetDlgItem(ID1_COMBO_PORT))->SetCurSel((PORT(TTYInfo)-1));

    FillComboBox(ID1_COMBO_BAUD,
		  szBaud, BaudTable,
		  sizeof(BaudTable)/sizeof(BaudTable[0]),
		  BAUDRATE(TTYInfo)) ;

    FillComboBox(ID1_COMBO_DATABITS,
		  szDataBits, DataBitsTable,
		  sizeof(DataBitsTable)/sizeof(DataBitsTable[0]),
		  BYTESIZE(TTYInfo)) ;

    FillComboBox(ID1_COMBO_PARITY,
		    szParity, ParityTable,
		    sizeof(ParityTable)/sizeof(ParityTable[0]),
		    PARITY(TTYInfo));

    FillComboBox(ID1_COMBO_STOPBITS,
		    szStopBits, StopBitsTable,
		    sizeof(StopBitsTable)/sizeof(StopBitsTable[0]),
		    STOPBITS(TTYInfo));

	UpdateData(TRUE);

	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));
	GetDlgItem(ID1_BTN_TIMERAA)->EnableWindow(CONNECTED(TTYInfo));
	GetDlgItem(ID1_BTN_STOPTIMER)->EnableWindow(FALSE);

	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// Զ庯

void CSerComDlg::FillComboBox(UINT nID, char **str, DWORD *nptab,
							  int tabLen, DWORD dwCurSetting)
{
	CComboBox* pCombo = (CComboBox*)GetDlgItem(nID);
    for (int i=0; i<tabLen; i++)
	{
		int index = pCombo->AddString(str[i]);
		pCombo->SetItemData(index, nptab[i]);
		
		if (nptab[i]==dwCurSetting)
			pCombo->SetCurSel(index);
    }
}

#define GetDlgComboBox(x) ((CComboBox*)GetDlgItem(x))
#define GetDlgComboData(x) (GetDlgComboBox(x)->GetItemData(GetDlgComboBox(x)->GetCurSel()))
void CSerComDlg::UpdateTTYInfo()
{
	UpdateData(TRUE);

	gszPort = m_gszPort;
	 AfxGetApp()->WriteProfileString(_T(""), _T("szPort"), m_gszPort);
	BAUDRATE(TTYInfo) = GetDlgComboData(ID1_COMBO_BAUD);
	PARITY(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_PARITY);
	BYTESIZE(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_DATABITS);
	STOPBITS(TTYInfo) = (BYTE)GetDlgComboData(ID1_COMBO_STOPBITS);
}

void CSerComDlg::SetComboSel(UINT nID, DWORD *nptab, int tabLen, DWORD value)
{
	for (int i=0; i<tabLen; i++)
	{
		if (nptab[i]==value)
		{
			GetDlgComboBox(nID)->SetCurSel(i);
			return;
		}
	}
}

void CSerComDlg::ShowCommState()
{
	SetComboSel(ID1_COMBO_BAUD,
				BaudTable,
				sizeof(BaudTable)/sizeof(BaudTable[0]),
				BAUDRATE(TTYInfo));
	SetComboSel(ID1_COMBO_PARITY,
				ParityTable,
				sizeof(ParityTable)/sizeof(ParityTable[0]),
				PARITY(TTYInfo));
	SetComboSel(ID1_COMBO_DATABITS,
				DataBitsTable,
				sizeof(DataBitsTable)/sizeof(DataBitsTable[0]),
				BYTESIZE(TTYInfo));
	SetComboSel(ID1_COMBO_STOPBITS,
				StopBitsTable,
				sizeof(StopBitsTable)/sizeof(StopBitsTable[0]),
				STOPBITS(TTYInfo));
}

/////////////////////////////////////////////////////////////////////////////
// CSerComDlg message handlers

void CSerComDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CDialog dlgAbout(IDD_ABOUTBOX);
		dlgAbout.DoModal();
	}
	else if (nID==SC_CLOSE)
		SendMessage(WM_CLOSE, 0, 0); 
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CSerComDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CSerComDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSerComDlg::OnClose() 
{
	KillTimer(1);
	if (CONNECTED(TTYInfo))
		BreakDownCommPort();

	DestroyWindow();
}

void CSerComDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent==1 && CONNECTED(TTYInfo))
	{
		char a = (char)0xaa;
		WriterGeneric(&a, 1);
	}

	CDialog::OnTimer(nIDEvent);
}

///////////////////////////////////////////////////////////////////////
// ԶϢ

void CSerComDlg::OnBtnConnect() 
{
	UpdateTTYInfo();
	//򿪶˿
	if (!SetupCommPort())
		return;
	ShowCommState();
	
	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));
	KillTimer(1);
	GetDlgItem(ID1_BTN_TIMERAA)->EnableWindow(CONNECTED(TTYInfo));
	GetDlgItem(ID1_BTN_STOPTIMER)->EnableWindow(FALSE);
}

void CSerComDlg::OnBtnDisconnect() 
{
	//رն˿
	BreakDownCommPort();
	//Ӱť״̬
	((CButton*)GetDlgItem(ID1_BTN_CONNECT))->EnableWindow(!CONNECTED(TTYInfo));
	((CButton*)GetDlgItem(ID1_BTN_DISCONNECT))->EnableWindow(CONNECTED(TTYInfo));
	GetDlgItem(ID1_BTN_TIMERAA)->EnableWindow(CONNECTED(TTYInfo));
}

void CSerComDlg::OnBtnInsert()
{
	CFileDialog ofdlg(TRUE,
		"txt",
		"",
		OFN_FILEMUSTEXIST|OFN_READONLY,
		"Text Files(*.txt)|*.txt|All Files(*.*)|*.*||",
		this);

	if (ofdlg.DoModal()==IDOK)
	{
		CFile f(ofdlg.GetPathName(), CFile::modeRead);
		//ļ
		CString stext;
		f.ReadHuge(stext.GetBufferSetLength(f.GetLength()),
				   f.GetLength());
		//滻ı
		m_resend.SetSel(0, m_resend.GetTextLength());
		m_resend.ReplaceSel(stext);
		m_resend.SetSel(0, 0);
	}
}

void CSerComDlg::OnBtnSend()
{
	if (!CONNECTED(TTYInfo))
	{
		::MessageBox(m_hWnd, "ûнӣ", NULL, MB_OK);
		return;
	}
	
	m_resend.HideSelection(TRUE, TRUE);
	m_resend.SetSel(0, m_resend.GetTextLength());
	CString strsend = m_resend.GetSelText();
	WriterGeneric((char*)((LPCTSTR)strsend), strsend.GetLength());
}

void CSerComDlg::OnBtnClearSend() 
{
	m_resend.HideSelection(TRUE, TRUE);
	m_resend.SetSel(0, m_resend.GetTextLength());
	m_resend.ReplaceSel("");
}

void CSerComDlg::OnBtnSendLine() 
{
	if (!CONNECTED(TTYInfo))
	{
		::MessageBox(m_hWnd, "ûнӣ", NULL, MB_OK);
		return;
	}
	UpdateData(TRUE);

	char tbuf[128], dbuf[64];
	int tlen = m_ledit.GetWindowText(tbuf, 128);
	char* p1 = tbuf;
	char* pe = tbuf + tlen;
	int dwData = 0, i=0;
	while (p1<pe)
	{
		while (p1<pe && !isxdigit(*p1)) p1++;
		if (p1>=pe) break;

		char buf[8];
		for (int j=0; p1<pe && j<2 && isxdigit(*p1); p1++)
			buf[j++] = *p1;
		buf[j] = 0;

		// ת16
		BYTE br;
		if (sscanf(buf, _T("%x"), &br)>0)
			dbuf[dwData++] = br;
	}
	WriterGeneric(dbuf, dwData);
}

void CSerComDlg::OnBtnClearLine() 
{
	GetDlgItem(ID1_EDIT_LHEX)->SetWindowText(_T(""));
}

void CSerComDlg::OnBtnTimeraa() 
{
	if (CONNECTED(TTYInfo))
	{
		DWORD dwTimer = AfxGetApp()->GetProfileInt(_T(""), _T("dwTimer"), 100);
		SetTimer(1, dwTimer, NULL);
		GetDlgItem(ID1_BTN_TIMERAA)->EnableWindow(FALSE);
		GetDlgItem(ID1_BTN_STOPTIMER)->EnableWindow(TRUE);
	}
}

void CSerComDlg::OnBtnStoptimer() 
{
	KillTimer(1);
	GetDlgItem(ID1_BTN_TIMERAA)->EnableWindow(CONNECTED(TTYInfo));
	GetDlgItem(ID1_BTN_STOPTIMER)->EnableWindow(FALSE);
}

void CSerComDlg::OnBtnClearRecv() 
{
	m_rerecv.HideSelection(TRUE, TRUE);
	m_rerecv.SetSel(0, m_rerecv.GetTextLength());
	m_rerecv.ReplaceSel("");
}

void CSerComDlg::OnCheckHex() 
{
	UpdateData(TRUE);
	gbHexShow = m_bHexShow;
	AfxGetApp()->WriteProfileInt(_T(""), _T("bHex"), m_bHexShow);
}

void CSerComDlg::OnBtnClose() 
{
	SendMessage(WM_CLOSE);
}
